// constants
// Rot. indicators => parameter value
const prod_angles_hifreq =[1250+1, 1660, 2080, 2500, 3125, 3750, 4375, 5000, 6250, 7500, 8750, 10000, 13340, 16680, 20000];
const prod_angles_midfreq=[ 125+1,  166,  208,  250,  312,  375,  437,  500,  625,  750,  875,  1000,  1334,  1668,  2000];
const prod_angles_lofreq =[  20+1,   16,   23,   40,   50,   60,   70,   80,  100,  120,  140,   160,   213,   266,   320];
const prod_angles_gain   =[-250+1, -200, -150, -100,  -50,  -34,  -16,    0,   16,   34,   50,    68,    84,   100,   150];
const prod_angles_aux    =[-600+1, -500, -400, -300, -200, -166, -132, -100,  -75,  -50,  -25,     0,    33,    66,   100];
const prod_angles_pan    =[     0,    3,    6,    9,   13,   16,   19,   23,   26,   30,   33,    36,    40,    43,    46];
// Production module's state
var prod_values=[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
var prod_leds  =[0, 0, 0, 0, 0, 0, 0, 0];

var prod_channel = null;
var prod_bypass = null;

var prod_src_name = null;
var prod_src_sync = null;

var prod_sel_src_id=src_NONE_id;	// selected src ID
var prod_src_list=[];		// source list {id:<SRCI>,name:<SRCN>}
var prod_src_count=0;		// size of source list

var prod_src_nr=0;			// index of selected source
var prod_src_nr_scr=0;	// current displayed index

// Enable Production Module (switch on leds/rot.indicators)
function prodEnable(channel_nr)
{
	var rmsg;

	if(prod_channel!=null) // production module is active
	{
		if(channel_nr==prod_channel) return; // same channel, nothing to do
		prodDisable();
	}
// check if current channel is a valid fader channel
	if(channel_nr==null || !(channel_nr in ch_data) || !ch_data[channel_nr].exists) return;

// request information about channel
	rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ",
		bSRCN:0, bSRCI:0, // source
		bEQHF:0, bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0, bEQAC:0, bEQHM:0, bEQLM:0, //eq
		bPANO:0, // pan
		bA1GN:0, bA2GN:0, bA3GN:0, bA4GN:0, // aux Gain
		bAUX1:0, bAUX2:0, bAUX3:0, bAUX4:0, // aux ON/OFF
		bA1PF:0, bA2PF:0, bA3PF:0, bA4PF:0  // aux PRE/POST
	});
	if(rmsg==null) return;	// unable to get correct answer

// enable production module
	prod_channel = channel_nr;
	prod_src_sync = false;

// we've got all the information we need
	mod.setProdIcon(prod_channel, 2);	// set channel number on icon
	prodIndi(rmsg);
	prodToggleLed(7, cfg_surroundMode?2:1);

// register us as a channel data handler
	pages.rxHandlersCh[prod_channel].prod={onIndi:prodIndi};

// request sources for this channel
	rmsg=getSourceList(prod_channel, true);
	prodSrcList(rmsg);
}

// Disable production module by turning off all indicators
function prodDisable()
{
	var n;

	if(prod_channel==null) return;
	delete pages.rxHandlersCh[prod_channel].prod;
	for(n=0; n<14; n++)
	{
		mod.setProdCBG(n, 0);
		prod_values[n]=0;
	}
	for(n=0; n<8; n++)
	{
		mod.setProdLED(n, 0);
		prod_leds[n]=0;
	}

	mod.setProdIcon(0);
	mod.setProdText("");
	prod_channel=null;
}

// Load the list of sources (for PM)
function prodSrcList(msg)
{
	var n, tag, src;

	prod_src_list=[];
	prod_src_list[0]={id:src_NONE_id, name:"NONE"};
	prod_src_count=1;
	prod_src_nr=prod_src_nr_scr=0;

	if(!msg) return;
	if(!('wSRLC' in msg)) {log.warning("malformed source list received"); return;}
	if('mSRLE' in msg)
	{
		for(n=1; n<=msg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in msg.mSRLE)) continue;

			src=msg.mSRLE[tag];
			if(!('sSRCN' in src) || !('dSRCI' in src)) continue;

			prod_src_list[prod_src_count]={id:src.dSRCI, name:src.sSRCN};
			if(src.dSRCI==prod_sel_src_id)
				prod_src_nr=prod_src_nr_scr=prod_src_count;
			prod_src_count++;
		}
	}
}

// Scroll sources
function prodSrcSelect(delta)
{
	var src_name;

	prod_src_nr_scr=inLimit(prod_src_nr_scr+delta, 0, prod_src_count-1);
	src_name=prod_src_list[prod_src_nr_scr].name;
	if(prod_src_nr_scr!=prod_src_nr)
	{
		mod.setProdText("*"+src_name);
	// FIXME: chage to arrow Up/Down when they are available
		mod.setProdIcon(prod_src_nr_scr<prod_src_nr?icons.ArrowLt:icons.ArrowRt);
	}
	else
	{
		mod.setProdText(src_name);
		mod.setProdIcon(prod_channel, 2);
	}
}

// Select new source
function prodSrcSelectConfirm()
{
	host.sendChnCmsg(prod_channel, {id:"WRIN", dSRCI:prod_src_list[prod_src_nr_scr].id});
	mod.setProdIcon(prod_channel, 2);
	mod.setProdText(prod_src_list[prod_src_nr_scr].name);
	prod_src_nr=prod_src_nr_scr;
}

// Message handler
function prodIndi(prmsg)
{
	if('bvSRCN' in prmsg)
	{
		prod_src_name=host.arrtostr(prmsg.bvSRCN);
		mod.setProdText(prod_src_name);
		for (var i = 0; i<prod_src_count; i++)
		{
			if (prod_src_list[i].name == prod_src_name)
			{
				prod_src_nr = i;
				prod_src_nr_scr = i;
				break;
			}
		}
	}
	if('dSRCI' in prmsg) prod_sel_src_id=prmsg.dSRCI;

// EQ
	if('wEQLF' in prmsg) prodSetKnob(9, prmsg.wEQLF, eq_range.f_lo);
	if('wEQMF' in prmsg) prodSetKnob(7, prmsg.wEQMF, eq_range.f_mid);
	if('wEQHF' in prmsg) prodSetKnob(5, prmsg.wEQHF, eq_range.f_hi);
	if('bEQAC' in prmsg) prod_bypass=prmsg.bEQAC;
	if('bEQHM' in prmsg) prodToggleLed(4, (prmsg.bEQHM == 1 ? 1 : 2));
	if('bEQLM' in prmsg) prodToggleLed(6, (prmsg.bEQLM == 1 ? 1 : 2));
// Gain
	if('wEQLG' in prmsg) prodSetKnob(8, prmsg.wEQLG, eq_range.gain);
	if('wEQMG' in prmsg) prodSetKnob(6, prmsg.wEQMG, eq_range.gain);
	if('wEQHG' in prmsg) prodSetKnob(4, prmsg.wEQHG, eq_range.gain);
// Aux
	if('wA1GN' in prmsg) prodSetKnob(0, prmsg.wA1GN, aux_const);
	if('wA2GN' in prmsg) prodSetKnob(1, prmsg.wA2GN, aux_const);
	if('wA3GN' in prmsg) prodSetKnob(2, prmsg.wA3GN, aux_const);
	if('wA4GN' in prmsg) prodSetKnob(3, prmsg.wA4GN, aux_const);

	if('bA1PF' in prmsg) prodToggleLed(0, prmsg.bA1PF+1);
	if('bA2PF' in prmsg) prodToggleLed(1, prmsg.bA2PF+1);
	if('bA3PF' in prmsg) prodToggleLed(2, prmsg.bA3PF+1);
	if('bA4PF' in prmsg) prodToggleLed(3, prmsg.bA4PF+1);

	if('bAUX1' in prmsg) if(prmsg.bAUX1==0) prodToggleLed(0, 0);
	if('bAUX2' in prmsg) if(prmsg.bAUX2==0) prodToggleLed(1, 0);
	if('bAUX3' in prmsg) if(prmsg.bAUX3==0) prodToggleLed(2, 0);
	if('bAUX4' in prmsg) if(prmsg.bAUX4==0) prodToggleLed(3, 0);

// Pan
	if('wvPANO' in prmsg)
	{
		var ind = panGetIdx(prmsg.wvPANO[0], prmsg.wvPANO[1]);
		prodSetKnob(10, ind, pan_const);
	}
}

// Buttons
function onProdKeyDown(key)
{
	if(prod_channel==null) return;

	switch(key)
	{
	case keys.PrdKnobSendA:
		prodToggleAuxLed(key-128, "bAUX1", "bA1PF");
		break;
	case keys.PrdKnobSendB:
		prodToggleAuxLed(key-128, "bAUX2", "bA2PF");
		break;
	case keys.PrdKnobSendC:
		prodToggleAuxLed(key-128, "bAUX3", "bA3PF");
		break;
	case keys.PrdKnobSendD:
		prodToggleAuxLed(key-128, "bAUX4", "bA4PF");
		break;
	case keys.PrdKnobEqHF:
		prodToggleEqLed(4);
		break;
	case keys.PrdKnobEqLG:
		prodToggleBypass();
		break;
	case keys.PrdKnobSrc:
		prodSrcSelectConfirm();
		break;
	}
}

function onProdKeyUp(key)
{
}

function prodNewSendGain(value, delta)
{
	if(value<=-400)
		value+=delta*30;
	else if(value<=-200)
		value+=delta*20;
	else if(value<=-100)
		value+=delta*10;
	else
		value+=delta*5;

	return clamp(value, aux_const.min, aux_const.max);
}

// knobs
function onProdRotaryEvent(index, delta, newValue)
{
	if(prod_channel==null) return;
	var value;

	switch(index)
	{
	case knobs.PrdSendA:
		host.sendChnCmsg(prod_channel, {id:'WRIN', wA1GN:prodNewSendGain(prod_values[0], delta)});
		break;
	case knobs.PrdSendB:
		host.sendChnCmsg(prod_channel, {id:'WRIN', wA2GN:prodNewSendGain(prod_values[1], delta)});
		break;
	case knobs.PrdSendC:
		host.sendChnCmsg(prod_channel, {id:'WRIN', wA3GN:prodNewSendGain(prod_values[2], delta)});
		break;
	case knobs.PrdSendD:
		host.sendChnCmsg(prod_channel, {id:'WRIN', wA4GN:prodNewSendGain(prod_values[3], delta)});
		break;
	case knobs.PrdEqHG:
		value=valAdjust(prod_values[4], delta, eq_range.gain);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wEQHG:value});
		break;
	case knobs.PrdEqMG:
		value=valAdjust(prod_values[6], delta, eq_range.gain);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wEQMG:value});
		break;
	case knobs.PrdEqLG:
		value=valAdjust(prod_values[8], delta, eq_range.gain);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wEQLG:value, bEQLM:(value<0?1:2)});
		break;
	case knobs.PrdEqHF:
		value=valAdjust(prod_values[5], delta, eq_range.f_hi);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wEQHF:value});
		break;
	case knobs.PrdEqMF:
		value=valAdjust(prod_values[7], delta, eq_range.f_mid);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wEQMF:value});
		break;
	case knobs.PrdEqLF:
		value=valAdjust(prod_values[9], delta, eq_range.f_lo);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wEQLF:value});
		break;
	case knobs.PrdPanLR:
		value=valAdjust(prod_values[10], delta, pan_const);
		host.sendChnCmsg(prod_channel, {id:'WRIN', wvPANO:pan_const.val_table[value]});
		break;
	case knobs.PrdSrc:
		// TODO: synchronize selection (cursor) in ch_src_page's sources list and PM sources list
		if(pages.open.id=='chsrc')
		{
			if(!prod_src_sync)
			{
				sknobsOnRot('jog', prod_src_nr_scr-delta);
				prod_src_sync=true;
			}
			sknobsOnRot('jog', delta);
		}
		else
			prodSrcSelect(delta);
		break;
	}
}

// Toggle AUX LEDs off/pre/post
function prodToggleAuxLed(prodknob, tag_on, tag_post)
{
	var msg={id:'WRIN'};
	var newValue;

	if(prod_leds[prodknob]==0)
	{
		msg[tag_on]=1;
		msg[tag_post]=0;
		newValue=1; // PRE
	}
	else if(prod_leds[prodknob]==1)
	{
		msg[tag_post]=1;
		newValue=2; // POST
	}
	else
	{
		msg[tag_on]=0;
		newValue=0; // OFF
	}
	prodToggleLed(prodknob, newValue);
	host.sendChnCmsg(prod_channel, msg);
}

// Toggle HighFreq led hi/shelf
function prodToggleEqLed(prodled)
{
	host.sendChnCmsg(prod_channel, {id:"WRIN", bEQHM:((prod_leds[prodled]==2) ? 1 : 0 )});
}

// Toggle Bypass  active/bypass
function prodToggleBypass()
{
	prod_bypass=(prod_bypass==0)?1:0;
	host.sendChnCmsg(prod_channel, {id:"WRIN", bEQAC:prod_bypass});
}

// Toggle PM's LEDs off/upper/lower/both
function prodToggleLed(prodled, newValue)
{
	prod_leds[prodled] = newValue;
	mod.setProdLED(prodled, newValue);
	return newValue;
}

// Indicate rotation
function prodSetKnob(prodknob, value, limit)
{
	var angle;

	value=clamp(value, limit.min, limit.max);
	prod_values[prodknob]=value;

	angle=prodCalcAngle(prodknob, value);
	mod.setProdCBG(prodknob, angle);

	return angle;
}

// Calculate angle for PM's rot. indicators (based on const. tables)
/* Oleg: FIXME: this is BADLY broken, can cause freeze; need to rewrite; Quick fix applied */
function prodCalcAngle(prodknob, value)
{
	// TODO: decide
	// change algorithm ?
	// remove "angle = (angle<<1)+1;" and calculate angle based on const. table ?
	var i = 0, angle = 0;
	switch (prodknob){
		case 0:
		case 1:
		case 2:
		case 3:
			while ((i in prod_angles_aux) && value >= prod_angles_aux[i] ){
				i++;
				angle = (angle<<1)+1;
			}
		break;
		case 4:
		case 6:
		case 8:
			while ((i in prod_angles_gain) && value >= prod_angles_gain[i] ){
				i++;
				angle = (angle<<1)+1;
			}
		break;
		case 5:
			while ((i in prod_angles_hifreq) && value >= prod_angles_hifreq[i] ){
				i++;
				angle = (angle<<1)+1;
			}
		break;
		case 7:
			while ((i in prod_angles_midfreq) && value >= prod_angles_midfreq[i] ){
				i++;
				angle = (angle<<1)+1;
			}
		break;
		case 9:
			while ((i in prod_angles_lofreq) && value >= prod_angles_lofreq[i] ){
				i++;
				angle = (angle<<1)+1;
			}
		break;
		case 10: //PAN
			angle = 1;
			while ((i in prod_angles_pan) && value >= prod_angles_pan[i] ){
				i++;
				angle = angle<<1;
			}
			return (angle>1) ? angle>>1 : angle;
		break;
	}
	return angle;
}

function prodSrcReload(mask)
{
	if(mask[prod_channel]==0) return;
	var prod_src_nr_scr_old = prod_src_nr_scr;
	// request sources for this channel
	var rmsg=getSourceList(prod_channel, true);
	if(rmsg!=null)
	{
		prodSrcList(rmsg);

		prod_src_nr_scr = (prod_src_nr_scr_old < prod_src_count) ? prod_src_nr_scr_old : prod_src_count - 1;
		var src_name = (prod_src_nr_scr == prod_src_nr) ? prod_src_list[prod_src_nr_scr].name : "*"+prod_src_list[prod_src_nr_scr].name;
		mod.setProdText(src_name);
	}
}
