// Element monitor section control

// ------------------------- * key mapping * -------------------------
var monMon1KeyToSSEL=[], monHpKeyToSSEL=[];
monMon1KeyToSSEL[keys.MstMon1Pgm1]=monInput.pgm1;
monMon1KeyToSSEL[keys.MstMon1Pgm2]=monInput.pgm2;
monMon1KeyToSSEL[keys.MstMon1Pgm3]=monInput.pgm3;
monMon1KeyToSSEL[keys.MstMon1Pgm4]=monInput.pgm4;
monMon1KeyToSSEL[keys.MstMon1AuxA]=monInput.send1;
monMon1KeyToSSEL[keys.MstMon1AuxB]=monInput.send2;
monMon1KeyToSSEL[keys.MstMon1AuxC]=monInput.send3;
monMon1KeyToSSEL[keys.MstMon1AuxD]=monInput.send4;
monMon1KeyToSSEL[keys.MstMon1Ext1]=monInput.ext1;
monMon1KeyToSSEL[keys.MstMon1Ext2]=monInput.ext2;

monMon1KeyToSSEL[keys.CmbMonPgm1]=monInput.pgm1;
monMon1KeyToSSEL[keys.CmbMonPgm2]=monInput.pgm2;
monMon1KeyToSSEL[keys.CmbMonPgm3]=monInput.pgm3;
monMon1KeyToSSEL[keys.CmbMonPgm4]=monInput.pgm4;
monMon1KeyToSSEL[keys.CmbMonExt1]=monInput.ext1;
monMon1KeyToSSEL[keys.CmbMonExt2]=monInput.ext2;

monHpKeyToSSEL[keys.MstHpPgm1]=monInput.pgm1;
monHpKeyToSSEL[keys.MstHpPgm2]=monInput.pgm2;
monHpKeyToSSEL[keys.MstHpPgm3]=monInput.pgm3;
monHpKeyToSSEL[keys.MstHpPgm4]=monInput.pgm4;
monHpKeyToSSEL[keys.MstHpAuxA]=monInput.send1;
monHpKeyToSSEL[keys.MstHpAuxB]=monInput.send2;
monHpKeyToSSEL[keys.MstHpAuxC]=monInput.send3;
monHpKeyToSSEL[keys.MstHpAuxD]=monInput.send4;
monHpKeyToSSEL[keys.MstHpExt1]=monInput.ext1;
monHpKeyToSSEL[keys.MstHpExt2]=monInput.ext2;

// ------------------------- * source set * -------------------------

function setMon1Source(source)
{
	host.sendNestCmsg('mCRMO', {id: "WRIN", bSSEL: source});
}

function setHpSource(source)
{
	if(mon_link)
		setMon1Source(source);
	else
		host.sendNestCmsg('mCRHP', {id: "WRIN", bSSEL: source});
}

// ------------------------- * event processing * -------------------------
var monExtTO=null, monExtKey=-1;

function onMon1KeyDown(key)
{
	var ssel;

	if(!(key in monMon1KeyToSSEL)) return; // unknown key
	ssel=monMon1KeyToSSEL[key];
	if(ssel==mon_mon1src) ssel=0;
	setMon1Source(ssel);

	pages.main.popMonCtr();
}

function onHpKeyDown(key)
{
	var ssel;

	if(!(key in monHpKeyToSSEL)) return; // unknown key
	ssel=monHpKeyToSSEL[key];
	if(ssel==mon_hpsrc) ssel=0;
	setHpSource(ssel);

	pages.main.popMonCtr();
}

function keyToExtChn(key)
{
	return (key==keys.MstHpExt1 || key==keys.MstMon1Ext1 || key==keys.CmbMonExt1)?chn_ext1:chn_ext2;
}

function openMonsrcPage()
{
	monExtTO=null;
	activatePage(pages.monsrc, keyToExtChn(monExtKey));
}

function onMonExtKeyDown(key)
{
	if(pages.open.id=="monsrc")
	{
		closePage(pages.monsrc, keyToExtChn(key));
		return;
	}

	if(monExtTO!=null)
	{
	// timeout is already active, clear it
		monExtTO=host.clearTimeout(monExtTO);
	// 1. Check for both ext keys press
		if((monExtKey==keys.CmbMonExt1 && key==keys.CmbMonExt2)
		|| (monExtKey==keys.CmbMonExt2 && key==keys.CmbMonExt1))
		{
			activatePage(pages.monsrc, chn_mon1);
			return;
		}
	}

	monExtTO=host.setTimeout(mon_const.page_open_time, openMonsrcPage);
	monExtKey=key;
}

function onMonExtKeyUp(key)
{
	if(monExtTO!=null && monExtKey==key)
	{
	// cancel timeout
		monExtTO=host.clearTimeout(monExtTO);
	// TODO: this is a hack to call both functions, but it's the simpliest solution for now
		onMon1KeyDown(key);
		onHpKeyDown(key);
	}
}

function indiMon1Src(src)
{
	var key;

	if(src!=mon_mon1src)
	{
	// special case for record mode: blinking pgm4
		if(mon_mon1src==monInput.rec) mon_mon1src=monInput.pgm4;
		for(key in monMon1KeyToSSEL)
		{
			if(monMon1KeyToSSEL[key]==mon_mon1src)
				mod.setMasterKeyLed(key, 0);
			if(monMon1KeyToSSEL[key]==src)
				mod.setMasterKeyLed(key, 255);
		}
		mon_mon1src=src;
	// special case for record mode: blinking pgm4
		if(mon_mon1src==monInput.rec)
		{
			for(key in monMon1KeyToSSEL)
				if(monMon1KeyToSSEL[key]==monInput.pgm4)
					mod.setMasterKeyLed(key, 4);
		}
	}
	if(mon_link) indiHpSrc(mon_mon1src); // update HP if link is on
}

function indiHpSrc(src)
{
	var key;

	if(src==mon_hpsrc) return;
// special case for record mode: blinking pgm4
	if(mon_hpsrc==monInput.rec) mon_hpsrc=monInput.pgm4;
	for(key in monHpKeyToSSEL)
	{
		if(monHpKeyToSSEL[key]==mon_hpsrc)
			mod.setMasterKeyLed(key, 0);
		if(monHpKeyToSSEL[key]==src)
			mod.setMasterKeyLed(key, 255);
	}
	mon_hpsrc=src;
// special case for record mode: blinking pgm4
	if(mon_hpsrc==monInput.rec)
	{
		for(key in monHpKeyToSSEL)
			if(monHpKeyToSSEL[key]==monInput.pgm4)
				mod.setMasterKeyLed(key, 4);
	}
}

// ------------------------- * Incoming CMsg * -------------------------

function onMon1Indi(msg)
{
	if('dLPID' in msg)
	{
		crmo_lpid=msg.dLPID;
	}
	if('bSSEL' in msg) indiMon1Src(msg.bSSEL);
	if('bWLGT' in msg)
	{
		crmo_wlgt=(msg.bWLGT!=0);
		gui_indi.setOnAir(crmo_wlgt || stmo_wlgt);
		phoneMuteRinger(crmo_wlgt);
	}
	if('sDISP' in msg)
		pages.main.mon1_src.setText(msg.sDISP);
	if('bESST' in msg)
	{
		ext1_src_status=msg.bESST;
		if(ext1_src_status==2) // source loaded
			pages.main.ext1_src.setProps({color:color.yellow});
		else // inactive, not found, error
			pages.main.ext1_src.setProps({color:color.red});
		object_blinker.add(pages.main.ext1_src, function(x) {return ext1_src_status!=2;}, true, null, null);
	}
	if(('bvNXTN' in msg) && ext1_src_status!=2)
	{
		ext1_src_name=host.arrtostr(msg.bvNXTN);
		pages.main.ext1_src.setText((ext1_src_status==7)?ext1_src_name+' IS INACTIVE':(ext1_src_status==8)?('SRC NOT FOUND'):'');
	}
	if(('bvSRCN' in msg) && ext1_src_status==2)
	{
		ext1_src_name=host.arrtostr(msg.bvSRCN);
		pages.main.ext1_src.setText(ext1_src_name);
	}
	if('bMUTE' in msg)
	{
		monSetMute(pages.main.mon1, msg.bMUTE);
		mon_mute.mon1=(msg.bMUTE==0);
	}
	if('bDIMD' in msg)
	{
		if(msg.bDIMD==0)
			pages.main.mon1_dim.show();
		else
			pages.main.mon1_dim.hide();
	}
}

function onHpIndi(msg)
{
// Monitor Link
	if('bINDP' in msg)
	{
		mon_link=(msg.bINDP==1);
		mod.setMasterKeyLed(keys.MstLink, mon_link?255:0);
		if(mon_link)
			indiHpSrc(mon_mon1src);
		else // request HP source
			host.sendNestCmsg('mCRHP', {id:'READ', bSSEL:0});
	}
	if('bSSEL' in msg)
	{
		if(!mon_link) indiHpSrc(msg.bSSEL);
	}
	if('sDISP' in msg)
		pages.main.hp_src.setText(msg.sDISP);
	if('bESST' in msg)
	{
		ext2_src_status=msg.bESST;
		if(ext2_src_status==2) // source loaded
			pages.main.ext2_src.setProps({color:color.yellow});
		else  // inactive, not found, error
			pages.main.ext2_src.setProps({color:color.red});
		object_blinker.add(pages.main.ext2_src, function(x) {return ext2_src_status!=2;}, true, null, null);
	}
	if(('bvNXTN' in msg) && ext2_src_status!=2)
	{
		ext2_src_name=host.arrtostr(msg.bvNXTN);
		pages.main.ext2_src.setText((ext2_src_status==7)?(ext2_src_name+' IS INACTIVE'):(ext2_src_status==8)?('SRC NOT FOUND'):'');
	}
	if(('bvSRCN' in msg) && ext2_src_status==2)
	{
		ext2_src_name=host.arrtostr(msg.bvSRCN);
		pages.main.ext2_src.setText(ext2_src_name);
	}
// Preview to HP
	if('bPVMO' in msg)
	{
		switch(msg.bPVMO)
		{
		case 1:	// OFF
			mod.setMasterKeyLed(keys.MstPvwToHp, 0);
			mod.setMasterKeyLed(keys.CmbPvwToHp, 0);
			pages.main.prev_hp.setText("OFF");
			pages.main.php_led.setIndex(0);
			break;
		case 2:	// STEREO
			mod.setMasterKeyLed(keys.MstPvwToHp, 255);
			mod.setMasterKeyLed(keys.CmbPvwToHp, 255);
			pages.main.prev_hp.setText("STEREO");
			pages.main.php_led.setIndex(1);
			break;
		case 3:	// SPLIT
			mod.setMasterKeyLed(keys.MstPvwToHp, 255);
			mod.setMasterKeyLed(keys.CmbPvwToHp, 255);
			pages.main.prev_hp.setText("SPLIT");
			pages.main.php_led.setIndex(1);
			break;
		}
	}
}

function onMon2Indi(msg)
{
	if('dLPID' in msg)
	{
		stmo_lpid=msg.dLPID;
	}
	if('bWLGT' in msg)
	{
		stmo_wlgt=(msg.bWLGT!=0);
		gui_indi.setOnAir(crmo_wlgt || stmo_wlgt);
	}
	if('sDISP' in msg)
		pages.main.mon2_src.setText(msg.sDISP);
	if('bMUTE' in msg)
	{
		monSetMute(pages.main.mon2, msg.bMUTE);
		mon_mute.mon2=(msg.bMUTE==0);
	}
	if('bDIMD' in msg)
	{
		if(msg.bDIMD==0)
			pages.main.mon2_dim.show();
		else
			pages.main.mon2_dim.hide();
	}
}

function onPrevIndi(msg)
{
	if('sDISP' in msg)
		pages.main.pvw_src.setText(msg.sDISP);
	if('bSTAT' in msg)
		gui_indi.setPview(msg.bSTAT!=0);
	if('bMUTE' in msg)
	{
		monSetMute(pages.main.pvw, msg.bMUTE);
		mon_mute.pvw=(msg.bMUTE==0);
	}
}
