// ------------------------ channel micproc page ------------------------

function chmicprocCtrlCreate(f, x, y, props)
{
	var obj={};

	obj.title=gui.newLabel(f, x+ 5, y, 30, 14, '', prop_value);
	obj.title.setText(props.title);
	obj.onoff=gui.newLabel(f, x+40, y, 40, 14, '', prop_value);
	obj.onoff.setText("BYPASS");
// 2 knobs with labels and values
	obj.thres=knobCreate(f, x   , y+17, 40, "THRES");
	obj.value=knobCreate(f, x+40, y+17, 40, props.value);

	obj.name=props.title;
	obj.valname=props.value;

	obj.v_onoff=0;
	obj.v_thres=0;
	obj.v_value=0;
	obj.a_thres=0;
	obj.a_value=0;

	obj.t_onoff=props.t_onoff;
	obj.t_thres=props.t_thres;
	obj.t_value=props.t_value;
	obj.thres_const=props.thres_const;
	obj.value_const=props.value_const;

	obj.focus=function(on)
	{
		var prop=on?propAct:propOff;

		this.title.setProps(prop);
		this.onoff.setProps(prop);
		this.thres.focus(on);
		this.value.focus(on);
	};

	obj.thres.val.setText("0 dB");
	obj.value.val.setText("-9 dB");

	return obj;
}

function chmicprocGainCtrlCreate(f, x, y)
{
	var obj={};
	var knob=
	{
		lbl:  gui.newLabel(f, x    , y+6, 76, 14, '', prop_value),
		val:  gui.newLabel(f, x+80 , y+6, 40, 14, '', prop_value),
		knob: gui.newKnob (f, x+120, y  , 22, 22, "img/knob_22px.png")
	};
	knob.lbl.setText("POST-PROC GAIN");
	knob.focus = function(on)
	{
		var prop=on?propAct:propOff;

		this.val.setProps(prop);
		this.lbl.setProps(prop);
		this.knob.setIndex(on?2:0);
	};
	obj.value=knob;
	obj.name="POST-PROC";
	obj.valname="GAIN";

	obj.a_value=0;
	obj.v_value=0;
	obj.t_value='wDYTG';
	obj.value_const=mic_range.trim_gain;
	obj.focus=function(on)
	{
		this.value.focus(on);
	};

	return obj;
}

function chmicprocPageCreate()
{
	var p={id:"chmicproc"};
	var f;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 145, 12, "img/channel_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);

	var fr=gui.newFrame(f, 48, 365, 356, 102, "img/micproc_bg.png");

	p.ctrl=[];
	p.ctrl[0]=chmicprocCtrlCreate(fr, 3    , 25, {title: "EXP"  , value: "DEPTH", t_onoff: 'bNGAC', t_thres: 'wNGTH', t_value: 'wNGGN', thres_const: mic_range.exp_thres, value_const: mic_range.exp_depth});
	p.ctrl[1]=chmicprocCtrlCreate(fr, 3+115, 25, {title: "COMP" , value: "RATIO", t_onoff: 'bCOAC', t_thres: 'wCOTH', t_value: 'wCORT', thres_const: mic_range.comp_thres, value_const: mic_range.comp_ratio});
	p.ctrl[2]=chmicprocCtrlCreate(fr, 3+230, 25, {title: "DE-ESS", value: "RATIO", t_onoff: 'bDEAC', t_thres: 'wDETH', t_value: 'wDERT', thres_const: mic_range.dess_thres, value_const: mic_range.dess_ratio});
	p.ctrl[3]=chmicprocGainCtrlCreate(fr, 190, 3);

// add meters
	var mtrexp, mtrcomp, mtrdess, mtrfrze;

	mtrexp =gui.newMeter(fr,  90, 32, 14, 60, "img/mic_meter.png");
	mtrcomp=gui.newMeter(fr, 204, 32, 14, 60, "img/mic_meter.png");
	mtrdess=gui.newMeter(fr, 318, 32, 14, 60, "img/mic_meter.png");
	mtrfrze=gui.newMeter(fr, 206, 20, 11, 11, "img/mtr_freeze.png");
	mtrexp .setBars(30); mtrexp .setPoints([-300, 30, 0, 0]); mtrexp .setDir(1);
	mtrcomp.setBars(30); mtrcomp.setPoints([-300, 30, 0, 0]); mtrcomp.setDir(1);
	mtrdess.setBars(20); mtrdess.setPoints([-200, 20, 0, 0]); mtrdess.setDir(1);
	mtrfrze.setBars( 1); mtrfrze.setPoints([0, 0, 1, 1]);
	gui.createMeter(mtrGUI.ch_mic, 6, null, [mtrexp, mtrcomp, mtrdess, mtrfrze]);

	p.como=false;

	p.focus=-1;
	p.gain_ctrl=false;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.ctrl) this.ctrl[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.ctrl) this.ctrl[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "EXP GATE\nTHRESH", push: "BYPASS"},
		{enabled: true, rot: "EXP GATE\nDEPTH"},
		{enabled: true, rot: "COMP\nTHRESH", push: "BYPASS"},
		{enabled: true, rot: "COMP\nRATIO", push: "NO FREEZE"},
		{enabled: true, rot: "DE-ESS\nTHRESH", push: "BYPASS"},
		{enabled: true, rot: "DE-ESS\nRATIO", push:"POST-PROC\nGAIN"}
	];
	p.sknobs3=
	[
		{enabled: false, rot: "THRESH", push: "BYPASS/\nACTIVE", jog: true, enter: true},
		{enabled: false, rot: "DEPTH/\nRATIO", push: "FREEZE/\nNO FREEZE", updn: true},
		{enabled: true,  rot: "FUNCTION", push: "EXIT", ltrt: true}
	];

// event functions
	p.onOpen =chmicprocOnOpen;
	p.onClose=chmicprocOnClose;
	p.onIndi =chmicprocIndi;
	p.onSoftKnobRot =chmicprocOnSoftKnobRot;
	p.onSoftKnobDown=chmicprocOnSoftKnobDown;
	p.onSoftKnobUp  =chmicprocOnSoftKnobUp;

	pages.chmicproc=p;
}
function chmicprocOnOpen(channel_nr)
{
	if(channel_nr==null) return;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	this.gain_ctrl=false;
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

	this.channel=channel_nr;
	this.title.label.setText(host.sprintf("CHANNEL %02d", channel_nr));

	var rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ",
		bNGAC:0, bCOAC:0, bDEAC:0,
		bNGTH:0, bCOTH:0, bDETH:0,
		bNGGN:0, bCORT:0, bDERT:0,
		bCOMO:0, bDYTG:0
	});
	if(rmsg!=null)
	{
		this.onIndi(rmsg);

	// request meters
		chnRequestMeter(this.channel, mtrEng.chnMic, mtrGUI.ch_mic, true);

	// register receive msg handlers
		pages.rxHandlersCh[this.channel].chmicproc=this;
		mod.setChnKeyLed(channel_nr, keys.ChnOptions, 255);
		mod.setMasterKeyLed(keys.MstChnEq, 255);
	}
}
function chmicprocOnClose()
{
	sknobsHide();

// release meters
	chnRequestMeter(this.channel, mtrEng.chnMic, mtrGUI.ch_mic, false);
// delete receive msg handlers
	delete pages.rxHandlersCh[this.channel].chmicproc;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setMasterKeyLed(keys.MstChnEq, 0);
}
function chmicprocIndi(chmsg)
{
	var n, ctrl, txt;

	for(n in this.ctrl)
	{
		ctrl=this.ctrl[n];
		if(('t_onoff' in ctrl) && (ctrl.t_onoff in chmsg))
		{
			ctrl.v_onoff=(chmsg[ctrl.t_onoff]==1);
			txt=ctrl.v_onoff?"ACTIVE":"BYPASS";
			ctrl.onoff.setText(txt);
			sknobsSetOne(n*2, {push: txt});
			if(this.focus==n)
				sknobsSetOne(6, {push: txt});
		}
		if(('t_thres' in ctrl) && (ctrl.t_thres in chmsg))
		{
			ctrl.v_thres=chmsg[ctrl.t_thres];
			ctrl.a_thres=knobSetValue(ctrl.thres, ctrl.v_thres, ctrl.thres_const);
			sknobsSetOne(n*2, {angleNrm: ctrl.a_thres});
			if(this.focus==n)
				sknobsSetOne(6, {angleNrm: ctrl.a_thres});
		}
		if(('t_value' in ctrl) && (ctrl.t_value in chmsg))
		{
			ctrl.v_value=chmsg[ctrl.t_value];
			ctrl.a_value=knobSetValue(ctrl.value, ctrl.v_value, ctrl.value_const);
			if(this.gain_ctrl && n==3)
				sknobsSetOne(5, {angleNrm: ctrl.a_value});
			else if(n!=3)
				sknobsSetOne(n*2+1, {angleNrm: ctrl.a_value});
			if(this.focus==n)
				sknobsSetOne(7, {angleNrm: ctrl.a_value});
		}
	}

// comp mode
	if('bCOMO' in chmsg)
	{
		this.como=(chmsg.bCOMO==2);
		txt=(this.como?"FREEZE":"NO FREEZE");
		sknobsSetOne(3, {push: txt});
		if(this.focus==1)
			sknobsSetOne(7, {push: txt});
	}
}
function chmicprocOnSoftKnobRot(idx, delta)
{
	var msg={id:'WRIN'};
	var n, ctrl;

	idx--; // fixme

	if(idx==8)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, 3));
		sknobsSetOne(8, {angleNrm: this.focus/3});
		ctrl=this.ctrl[this.focus];
		if('t_thres' in ctrl)
			sknobsSetOne(6, {enabled: true, rot: ctrl.name+"\nTHRESH", push:ctrl.v_onoff?"ACTIVE":"BYPASS", angleNrm: ctrl.a_thres});
		else
			sknobsSetOne(6, {enabled: false, rot: "THRESH", push: "BYPASS/\nACTIVE", angleNrm:0});
		if('t_value' in ctrl) sknobsSetOne(7, {enabled: true, rot: ctrl.name+"\n"+ctrl.valname, push:this.focus==1?(this.como?"FREEZE":"NO FREEZE"):null, angleNrm: ctrl.a_value});
		return;
	}

	if(idx>=0 && idx<=4)
		n=idx>>1;
	else if(idx==5)
		n=(this.gain_ctrl?3:2);
	else
		n=this.focus;

	if(n in this.ctrl)
	{
		ctrl=this.ctrl[n];

		if(idx&1) // Value
		{
			if(!('t_value' in ctrl)) return;
			msg[ctrl.t_value]=valAdjust(ctrl.v_value, delta, ctrl.value_const);
		}
		else // Thresh
		{
			if(!('t_thres' in ctrl)) return;
			msg[ctrl.t_thres]=valAdjust(ctrl.v_thres, delta, ctrl.thres_const);
		}
		host.sendChnCmsg(this.channel, msg);
	}
}
function chmicprocOnSoftKnobDown(idx)
{
	var msg={id:'WRIN'};
	var n, ctrl;

	idx--; // fixme

	if(idx>=0 && idx<=5)
		n=idx>>1;
	else
		n=this.focus;

	if(idx&1)
	{
		if(n==1) // Compressor mode
			host.sendChnCmsg(this.channel, {id:"WRIN", bCOMO: (this.como?1:2)});
	}
	else
	{
		if(n in this.ctrl)
		{
			ctrl=this.ctrl[n];
			if(!('t_onoff' in ctrl)) return;
			msg[ctrl.t_onoff]=ctrl.v_onoff?0:1;
			host.sendChnCmsg(this.channel, msg);
		}
	}
}
function chmicprocOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
		if(this.gain_ctrl)
		{
			this.gain_ctrl=false;
			sknobsSetOne(5, {rot:"DE-ESS\nRATIO", push:"POST-PROC\nGAIN", angleNrm:this.ctrl[2].a_value});
		}
		else
		{
			this.gain_ctrl=true;
			sknobsSetOne(5, {rot:"POST-PROC\nGAIN", push:"DE-ESS\nRATIO", angleNrm:this.ctrl[3].a_value});
		}
		break;
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
